<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: COM_OrdenItemClasificacion.xml */
/* Generado: 2021-06-25 23:59:45 */

/* Busqueda de registros de la tabla COM_OrdenItemClasificacion. */
abstract class BaseCOM_OrdenItemClasificacionFN extends COM_OrdenItemClasificacionBN
{
    /* Declaracion de constantes */
    const IdOrdenClasificacion = "COM_OrdenItemClasificacion.IdOrdenClasificacion";
    const IdCompania = "COM_OrdenItemClasificacion.IdCompania";
    const CodigoSunat = "COM_OrdenItemClasificacion.CodigoSunat";
    const NombreCompania = "COM_OrdenItemClasificacion.NombreCompania";
    const IdItemTipo = "COM_OrdenItemClasificacion.IdItemTipo";
    const Descripcion = "COM_OrdenItemClasificacion.Descripcion";
    const IdAlmacen = "COM_OrdenItemClasificacion.IdAlmacen";
    const Estado = "COM_OrdenItemClasificacion.Estado";
    const FechaCreacion = "COM_OrdenItemClasificacion.FechaCreacion";
    const UsuarioCreacion = "COM_OrdenItemClasificacion.UsuarioCreacion";
    const FechaModificacion = "COM_OrdenItemClasificacion.FechaModificacion";
    const UsuarioModificacion = "COM_OrdenItemClasificacion.UsuarioModificacion";

    public $a_Condition = array();
    public $a_OrderBy = array();
    public $a_GroupBy = array();
    public $b_Debug = false;

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        return $o_DBConnect;
    }

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "COM_OrdenItemClasificacion.IdOrdenClasificacion AS IdOrdenClasificacion, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.IdCompania AS IdCompania, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.CodigoSunat AS CodigoSunat, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.NombreCompania AS NombreCompania, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.IdItemTipo AS IdItemTipo, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.Descripcion AS Descripcion, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.IdAlmacen AS IdAlmacen, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.Estado AS Estado, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.FechaCreacion AS FechaCreacion, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.UsuarioCreacion AS UsuarioCreacion, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.FechaModificacion AS FechaModificacion, ";
        $s_SQLQuery .= "COM_OrdenItemClasificacion.UsuarioModificacion AS UsuarioModificacion ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_ComSimple = true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "FLAG_COMILLAS" => $b_ComSimple );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece el orden de la lista resultante */
    public function addGroupBy( $s_Const )
    {
        $this->a_GroupBy[] = array( "COLUMN" => $s_Const );
    }

    /* Establece los valores desde un objeto COM_OrdenItemClasificacionBN */
    public function setByBN( COM_OrdenItemClasificacionBN $o_COM_OrdenItemClasificacionBN )
    {
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdOrdenClasificacion() ) )
        {
            $this->setIdOrdenClasificacion( $o_COM_OrdenItemClasificacionBN->getIdOrdenClasificacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_COM_OrdenItemClasificacionBN->getIdCompania() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getCodigoSunat() ) )
        {
            $this->setCodigoSunat( $o_COM_OrdenItemClasificacionBN->getCodigoSunat() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getNombreCompania() ) )
        {
            $this->setNombreCompania( $o_COM_OrdenItemClasificacionBN->getNombreCompania() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdItemTipo() ) )
        {
            $this->setIdItemTipo( $o_COM_OrdenItemClasificacionBN->getIdItemTipo() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_COM_OrdenItemClasificacionBN->getDescripcion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_COM_OrdenItemClasificacionBN->getIdAlmacen() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getEstado() ) )
        {
            $this->setEstado( $o_COM_OrdenItemClasificacionBN->getEstado() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_COM_OrdenItemClasificacionBN->getFechaCreacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_COM_OrdenItemClasificacionBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_COM_OrdenItemClasificacionBN->getFechaModificacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_COM_OrdenItemClasificacionBN->getUsuarioModificacion() );
        }
    }

    /**
    * @return COM_OrdenItemClasificacionBN|null
    * @throws SQLException
    */
    public function selectByPK( $s_IdOrdenClasificacion )
    {
        if( is_null( $s_IdOrdenClasificacion ) ){ $s_IdOrdenClasificacion = '-1'; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM COM_OrdenItemClasificacion ";
        $s_SQLQuery .= "WHERE IdOrdenClasificacion = '".$s_IdOrdenClasificacion."' ";
        $s_SQLQuery .= "LIMIT 1;";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_COM_OrdenItemClasificacionBN = null;
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows   = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            $o_ResultSet->next();
            $a_SQLRow = $o_ResultSet->getRow(); //devuele array
            $o_COM_OrdenItemClasificacionBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_COM_OrdenItemClasificacionBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getIdOrdenClasificacion() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.IdOrdenClasificacion = '".$this->getIdOrdenClasificacion()."' AND ";
        if ( !is_null( $this->getIdCompania() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.IdCompania = ".$this->getIdCompania()." AND ";
        if ( !is_null( $this->getCodigoSunat() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.CodigoSunat = '".$this->getCodigoSunat()."' AND ";
        if ( !is_null( $this->getNombreCompania() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.NombreCompania = '".$this->getNombreCompania()."' AND ";
        if ( !is_null( $this->getIdItemTipo() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.IdItemTipo = '".$this->getIdItemTipo()."' AND ";
        if ( !is_null( $this->getDescripcion() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.Descripcion = '".$this->getDescripcion()."' AND ";
        if ( !is_null( $this->getIdAlmacen() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.IdAlmacen = '".$this->getIdAlmacen()."' AND ";
        if ( !is_null( $this->getEstado() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.Estado = '".$this->getEstado()."' AND ";
        if ( !is_null( $this->getFechaCreacion() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.FechaCreacion = '".$this->getFechaCreacion()."' AND ";
        if ( !is_null( $this->getUsuarioCreacion() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.UsuarioCreacion = '".$this->getUsuarioCreacion()."' AND ";
        if ( !is_null( $this->getFechaModificacion() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.FechaModificacion = '".$this->getFechaModificacion()."' AND ";
        if ( !is_null( $this->getUsuarioModificacion() ) ) $s_SQLQuery .= "COM_OrdenItemClasificacion.UsuarioModificacion = '".$this->getUsuarioModificacion()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['FLAG_COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM COM_OrdenItemClasificacion WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $o_ResultSet->next();
        $i_NumRows    = $o_ResultSet->getInt( 'cnt' );
        return $i_NumRows;
    }

    /**
    * @param null $i_Position
    * @param null $i_Rows
    * @return COM_OrdenItemClasificacionBN[]
    * @throws SQLException
    */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM COM_OrdenItemClasificacion WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        $a_COM_OrdenItemClasificacionBN = array();
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            while( $o_ResultSet->next() ) 
            {
                $a_SQLRow = $o_ResultSet->getRow(); //devuele array
                $o_COM_OrdenItemClasificacionBN = $this->insertObjectBN( $a_SQLRow );
                $a_COM_OrdenItemClasificacionBN[] = $o_COM_OrdenItemClasificacionBN;
            }
        }
        return $a_COM_OrdenItemClasificacionBN;
    }

    /* Devuelve un objeto COM_OrdenItemClasificacionBN desde un objeto propel */
    public function insertObjectBN( $a_COM_OrdenItemClasificacion )
    {
        $o_COM_OrdenItemClasificacionBN = new COM_OrdenItemClasificacionBN();
        if ( !is_null( $a_COM_OrdenItemClasificacion['IdOrdenClasificacion'] ) ) $o_COM_OrdenItemClasificacionBN->setIdOrdenClasificacion( $a_COM_OrdenItemClasificacion['IdOrdenClasificacion'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['IdCompania'] ) ) $o_COM_OrdenItemClasificacionBN->setIdCompania( ( integer ) $a_COM_OrdenItemClasificacion['IdCompania'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['CodigoSunat'] ) ) $o_COM_OrdenItemClasificacionBN->setCodigoSunat( $a_COM_OrdenItemClasificacion['CodigoSunat'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['NombreCompania'] ) ) $o_COM_OrdenItemClasificacionBN->setNombreCompania( $a_COM_OrdenItemClasificacion['NombreCompania'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['IdItemTipo'] ) ) $o_COM_OrdenItemClasificacionBN->setIdItemTipo( $a_COM_OrdenItemClasificacion['IdItemTipo'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['Descripcion'] ) ) $o_COM_OrdenItemClasificacionBN->setDescripcion( $a_COM_OrdenItemClasificacion['Descripcion'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['IdAlmacen'] ) ) $o_COM_OrdenItemClasificacionBN->setIdAlmacen( $a_COM_OrdenItemClasificacion['IdAlmacen'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['Estado'] ) ) $o_COM_OrdenItemClasificacionBN->setEstado( $a_COM_OrdenItemClasificacion['Estado'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['FechaCreacion'] ) ) $o_COM_OrdenItemClasificacionBN->setFechaCreacion( utilTimestamp::getTimestamp( $a_COM_OrdenItemClasificacion['FechaCreacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_COM_OrdenItemClasificacion['UsuarioCreacion'] ) ) $o_COM_OrdenItemClasificacionBN->setUsuarioCreacion( $a_COM_OrdenItemClasificacion['UsuarioCreacion'] );
        if ( !is_null( $a_COM_OrdenItemClasificacion['FechaModificacion'] ) ) $o_COM_OrdenItemClasificacionBN->setFechaModificacion( utilTimestamp::getTimestamp( $a_COM_OrdenItemClasificacion['FechaModificacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_COM_OrdenItemClasificacion['UsuarioModificacion'] ) ) $o_COM_OrdenItemClasificacionBN->setUsuarioModificacion( $a_COM_OrdenItemClasificacion['UsuarioModificacion'] );
        return $o_COM_OrdenItemClasificacionBN;
    }
}
?>